/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('estratecmsimage', 'en,de,sv,zh_cn,cs,fa,fr_ca,fr,pl,pt_br,nl,he,no');

function TinyMCE_estratecmsimage_getInfo() {
	return {
		longname : 'Estratecms images plugin',
		author : 'Email Communications',
		authorurl : 'http://www.emailcommunications.nl/',
		infourl : 'http://www.estratecms.org/',
		version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
	};
};

function TinyMCE_estratecmsimage_getControlHTML(control_name) {
	
	switch (control_name) {
		
		case "image":
			return '<a href="javascript:tinyMCE.execInstanceCommand(\'{$editor_id}\',\'mceestratecmsimage\');" target="_self" onmousedown="return false;"><img id="{$editor_id}_estratecmsimage" src="{$themeurl}/images/image.gif" title="{$lang_image_desc}" width="20" height="20" class="mceButtonNormal" onmouseover="tinyMCE.switchClass(this,\'mceButtonOver\');" onmouseout="tinyMCE.restoreClass(this);" onmousedown="tinyMCE.restoreClass(this);" /></a>';
	}

	return "";
}

function TinyMCE_estratecmsimage_execCommand(editor_id, element, command, user_interface, value) {
	switch (command) {
		case "mceestratecmsimage":
			var template = new Array();

			template['file']   = tinyMCE.settings['path']+'image.php?item_language='+tinyMCE.settings['item_language'];
			template['width']  = 700;
			template['height'] = 380;

			// Language specific width and height addons
			template['width']  += tinyMCE.getLang('lang_estratecmsimage_delta_width', 0);
			template['height'] += tinyMCE.getLang('lang_estratecmsimage_delta_height', 0);

			tinyMCE.openWindow(template, {editor_id : editor_id, inline : "yes", scrollbars:"yes"});

			return true;
	}

	return false;
}

function TinyMCE_estratecmsimage_cleanup(type, content) {
	switch (type) {
		case "insert_to_editor_dom":
			var imgs = content.getElementsByTagName("img");
			for (var i=0; i<imgs.length; i++) {
				var onmouseover = tinyMCE.cleanupEventStr(tinyMCE.getAttrib(imgs[i], 'onmouseover'));
				var onmouseout = tinyMCE.cleanupEventStr(tinyMCE.getAttrib(imgs[i], 'onmouseout'));

				if ((src = tinyMCE.getImageSrc(onmouseover)) != "") {
					src = tinyMCE.convertRelativeToAbsoluteURL(tinyMCE.settings['base_href'], src);
					imgs[i].setAttribute('onmouseover', "this.src='" + src + "';");
				}

				if ((src = tinyMCE.getImageSrc(onmouseout)) != "") {
					src = tinyMCE.convertRelativeToAbsoluteURL(tinyMCE.settings['base_href'], src);
					imgs[i].setAttribute('onmouseout', "this.src='" + src + "';");
				}
			}
			break;

		case "get_from_editor_dom":
			var imgs = content.getElementsByTagName("img");
			for (var i=0; i<imgs.length; i++) {
				var onmouseover = tinyMCE.cleanupEventStr(tinyMCE.getAttrib(imgs[i], 'onmouseover'));
				var onmouseout = tinyMCE.cleanupEventStr(tinyMCE.getAttrib(imgs[i], 'onmouseout'));

				if ((src = tinyMCE.getImageSrc(onmouseover)) != "") {
					src = eval(tinyMCE.settings['urlconverter_callback'] + "(src, null, true);");
					imgs[i].setAttribute('onmouseover', "this.src='" + src + "';");
				}

				if ((src = tinyMCE.getImageSrc(onmouseout)) != "") {
					src = eval(tinyMCE.settings['urlconverter_callback'] + "(src, null, true);");
					imgs[i].setAttribute('onmouseout', "this.src='" + src + "';");
				}
			}
			break;
	}

	return content;
}


function TinyMCE_estratecmsimage_handleNodeChange : function(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		if (node == null)
			return;

		do {
			if (node.nodeName == "HR") {
				tinyMCE.switchClass(editor_id + '_estratecmsimage', 'mceButtonSelected');
				return true;
			}
		} while ((node = node.parentNode));

		tinyMCE.switchClass(editor_id + '_estratecmsimage', 'mceButtonNormal');

		return true;
	}
