<?php
define( 'MODULE_CMSLANGUAGES', TRUE );

class cmslanguages
{
	function getArray()
	{
		/*
		   returns array like
		   array( 'nl' => 'Dutch', 'en' => 'English' );
		   If no language definition for the default language is present it returns:
		   array( 'nl' => 0, 'en' => 1 );
		*/
		if( strpos( CMS_LANGUAGES, ',' ) ) {
			$langs = explode( ',', CMS_LANGUAGES );
		} else {
			$langs = array( CMS_LANGUAGES );
		}
		if( defined( 'LANGUAGES_'.strtoupper( CMS_LANGUAGES_DEFAULT ) ) ) {
			foreach( $langs as $lang ) {
				$output[$lang] = constant( 'LANGUAGES_'.strtoupper( $lang ) );
			}
		} else {
			$output = array_flip( $langs );
		}
		return $output;
	}

	function loadTranslation( $lang )
	{
		$lang = strtolower( $lang );
		require_once( $lang.'.php' );
	}
	
	function loadAdminTranslation( $lang )
	{
		global $menu_titles;
		$lang = strtolower( $lang );
		require_once( 'admin.'.$lang.'.php' );
		require_once( $lang.'.php' );
	}

	function getAllLanguages()
	{
		//iso639 copy-pasted from http://www.w3.org/WAI/ER/IG/ert/iso639.htm
		$fh = fopen( CMS_LIB_PATH.'cmslanguages/iso639.txt', 'r' );
		while( $fh && !feof( $fh ) ) {
			$line = trim( fgets( $fh ) );
			$key = strtolower( substr( $line, 0, 2 ) );
			$title = trim( ucwords( substr( $line, 4 ) ) );
			$title = substr( $title, 0, strpos( $title, '"' ) );
			$result[$key] = $title;
		}
		fclose( $fh );
		asort( $result );
		return $result;
	}
}

?>