<?php
define( 'MODULE_CMSUSERS', TRUE );
myautoload('form');
class cmsusers extends EstrateDB
{
	var	$id;
	var	$username;
	var	$password;
	var	$publicalias;
	var	$email;
	var	$msn;
	var $phone;
	var $gsm;
	var $fax;
	var	$givenname;
	var	$infix;
	var	$familyname;
	var $jobtitle;
	var	$gender;
	var $address;
	var $zipcode;
	var	$country;
	var	$city;
	var $state;
	var	$homepage;
	var	$profieltekst;
	var	$organisation;
	var $departement;
	var $vatnumber;
	var	$mailing;
	var	$language;
	var	$type;
	var	$status;
	var	$update_time;
	var	$insert_time;
	var	$confirmcode;
	var	$securityinfo;
	var $photo;
	var $birthday;
	var	$_tablename_stats = 'cmsusersstats';
	
	function cmsusers( &$db )
	{
		EstrateDB::EstrateDB( $db );
		cmsconfig::load_contants('cmsusers');
		
		require_once( (defined( 'CMS_CURRENT_LANGUAGE' )?CMS_CURRENT_LANGUAGE:CMS_LANGUAGES_DEFAULT).'.php' );
		
		if( !defined( 'CMS_USERS_AUTOLOGOUT' ) ) {
			define( 'CMS_USERS_AUTOLOGOUT', 2400 );
		}
		if( !defined( 'CMS_USERS_REGISTRATIONMETHOD' ) ) {
			define( 'CMS_USERS_REGISTRATIONMETHOD', 'notifyadmin' );
		}
		
		
		if( !defined( 'CMS_USERS_LOGIN_URL' ) ) {
			define( 'CMS_USERS_LOGIN_URL', 'login/' );
		}
		if( !defined( 'CMS_USERS_REG_URL' ) ) {
			define( 'CMS_USERS_REG_URL', 'register/' );
		}
		
		
	}
	
	function save()
	{
		if( !$this->password || !$this->email || !$this->username ) {
			$this->_err = "Password, e-mail and username are required. Please try again.";
			return FALSE;
		}
		if(isset($_POST['birthday_month']))$this->birthday=mktime(0,0,0,$_POST['birthday_month'],$_POST['birthday_day'],$_POST['birthday_year']);
		return EstrateDB::save();
	}

	function check()
	{
		if( !$this->insert_time ) $this->insert_time = time();
		$this->update_time = time();
		if( !$this->language ) {
			$this->language = CMS_CURRENT_LANGUAGE;
		}
		if( !$this->securityinfo ) {
			$this->securityinfo = getSecurityInfo();
		}
		$this->language = substr( strtolower( $this->language ), 0, 2);
		$this->confirmcode = intval( $this->confirmcode );
		$this->email = cleanEmail( $this->email );
		$this->username = cleanUsername( $this->username );
		$this->publicalias = strip_tags( $this->publicalias );
		$this->givenname = strip_tags( $this->givenname );
		$this->familyname = strip_tags( $this->familyname );
		$this->organisation = strip_tags( $this->organisation );
		if( !$this->type ) {
			$this->type = 'user';
		}
		//add more cleaning
		return TRUE;
	}

	function login()
	{

		//session_cache_limiter('private_no_expire');
		//var_dump($_SERVER);
		session_cache_expire( ceil( CMS_USERS_AUTOLOGOUT / 60 ) );
		if(!isset($_SESSION))session_start();
		if(isset($_POST['logout']) || isset($_GET['logout']))$this->unsetSession(1);
		if(defined('CMS_SAVEIPS') && !strstr(CMS_SAVEIPS,$_SERVER['SERVER_ADDR']))
		{
			$this->unsetSession();
			return false;
		}

		if( isset( $_POST['username'] ) && $_POST['username'] && isset( $_POST['password'] ) && $_POST['password'] ) {
			$this->username = strtolower( $_POST['username'] );
			
			$this->password = md5( $_POST['password'] );
		} elseif( isset( $_SESSION['username'] ) && $_SESSION['username'] && $_SESSION['password'] && $_SESSION['time'] && time()-$_SESSION['time']<intval( CMS_USERS_AUTOLOGOUT ) ) 
		{
			$this->username = $_SESSION['username'];
			$this->password = $_SESSION['password'];
			
		} else {
			$this->unsetSession();
			return FALSE;
		}
		$field=(defined('CMS_USEEMAIL') && CMS_USEEMAIL==1 && isset( $_POST['username'] ))?'email':'username';

		$sql = 'SELECT id, password FROM '.$this->_tablename.' WHERE `'.$field.'`=\''.$this->username.'\' AND status=\'on\' AND NOT confirmcode';

		$rs = $this->_db->Execute( $sql );
		
		if( $rs->RecordCount()==1 ) 
		{
			$tmp = $rs->FetchRow();
			
			if( $this->password == $tmp['password'] ) 
			{ 
				$this->load( $tmp['id'] );
				$this->setSession();
				return TRUE;
			} else {
				//echo 'wrong password'; exit;
    
				define('error',CMSUSERS_WRONGPASSWORD);
				$this->unsetSession();
				return FALSE;
			}
		} else {
			//echo 'user does not exist'; exit;
			//$this->_error = USERS_WRONGUSERNAME;
			define('error',CMSUSERS_WRONGUSERNAME);
			$this->unsetSession();
			return FALSE;
		}

		$this->unsetSession();
		return FALSE;
	}

	function hasRights( $required, $current = '' )
	{

		/*
		
			Let op hier worden voor verschillende soorten gebruikers gewichten toegevoegd, dit zou per site moeten zijn
			Uiteindelijk willen we hier iets met users / groups......
		
		*/
		
		
		$weight = array(
			'superadmin'	=> 1000,
			'admin'		    => 500,
			'editor'	    => 400,
			'reviewer'	    => 300,
			'member'	    => 200,
			'user'		    => 100,
			'downloaduser'	=> 101,
			'none'		=> 0
		);
		if( !$current && isset($this->type) ) {
			$current = $this->type;
		} elseif( !$current ) {
			$current = 'none';
		}

		if( isset( $weight[$required] ) && isset( $weight[$current] ) ) {
			//if weight of user is bigger or equal to required weight, user has rights
		
			if( $required == 'none' || intval( $weight[$current] ) >= intval( $weight[$required] ) ) {
					return TRUE;
			} else {
				return FALSE;
			}
		} else {
			//type does not exist, or invalid user
			return FALSE;
		}
	}

	function getRightsArray()
	{
		return array(
			'none'		=> ADM_CMSUSERS_NORIGHTS,
			'user'		=> ADM_CMSUSERS_USER,
			'downloaduser'		=> ADM_CMSUSERS_USER,
			'member'	=> ADM_CMSUSERS_MEMBER,
			'reviewer'	=> ADM_CMSUSERS_REVIEWER,
			'editor'	=> ADM_CMSUSERS_EDITOR,
			'admin'		=> ADM_CMSUSERS_ADMIN,
			'superadmin'	=> ADM_CMSUSERS_SUPERADMIN
		);
	}

	function showRegistration( $input ) {

		if( CMS_CURRENT_ID ) {
			return $this->confirmRegistration();
		} elseif( isset( $_POST['registration'] ) ) 
		
		{
			//try to save user registration, send e-mails to user & admin
			list($errors,$errorclasses) = $this->checkRegistration();
			if( count($errors)>0 ) {
				//errors did occur
				$templ = cmstemplates::loadfile( 'cmsusers_reg_error_item', $this->_tablename );
				$error_list = '';
				foreach( $errors as $error ) {
					$error_list .= cmstemplates::parse( $templ, array( 'error' => $error ) );
				}
				$errors = cmstemplates::show( 'cmsusers_reg_errors', $this->_tablename, array( 'errors' => $error_list ) );
				
				
				return $this->showregistrationform($errors,$errorclasses);
		} 
			
			else {
				//check = ok
				$vars = array();
				$vars['title'] = CMSUSERS_REG_END;
				if( $this->save() ) {
					if( $this->sendRegistrationMail() ) {
						$vars['message'] = CMSUSERS_REG_MAIL_SEND;
					} else {
						$vars['message'] = CMSUSERS_REG_MAIL_NOTSEND;
					}
				} else {
					$vars['message'] = CMSUSERS_REG_NOTSAVED;
				}
				return cmstemplates::show( 'message', $this->_tablename, $vars );
			}
		} 
		elseif( isset( $_POST['conditions_agreed']) || isset( $_GET['conditions_agreed'] ) ) 
		
		{
			return $this->showregistrationform();
		} 
		
		else {
			//ask to agree on conditions
			return cmstemplates::show( 'cmsusers_conditions.'.CMS_CURRENT_LANGUAGE, $this->_tablename, '' );
		}
	}
	
	function showregistrationform($errors='',$errorclasses='')
	{
			$vars['errors']=empty($errors)?'':'<div class="error">'.$errors.'</div><br />';
			//show registration form

			if( CMS_USERS_REGISTRATIONMETHOD == 'askadmin' ) {
				$vars['explain_extra'] = CMSUSERS_REG_EXPLAIN_ASKADMIN;
			} elseif( CMS_USERS_REGISTRATIONMETHOD == 'notifyadmin' ) {
				$vars['explain_extra'] = CMSUSERS_REG_EXPLAIN_NOTIFYADMIN;
			} else {
				$vars['explain_extra'] = CMSUSERS_REG_EXPLAIN_FREE;
			}
			$langs = cmslanguages::getArray();
			if( count( $langs ) > 1 ) {
				$vars['language_select'] = cmstemplates::selectList( 'language', $langs, '' );
			} else {
				$vars['language_select'] = $langs[CMS_CURRENT_LANGUAGE];
			}
			
	
			if(is_array( $errorclasses))
			{
				foreach ($errorclasses as $k=>$v)
				{
					$vars[$k.'error']='error';
				}	
			}
			if(isset($_POST))$vars=array_merge($vars,$_POST);
			$vars['gender_select'] = form::selectList( 'gender', array('female'=>CMSUSERS_FEMALE,'male'=>CMSUSERS_MALE), isset($_POST['gender'])?$_POST['gender']:'' );
			
			/*include(CMS_LIB_PATH.'/data/landen.php');
			foreach ($landen as $land)$landen2[$land]=$land;*/
			
			include(CMS_LIB_PATH.'/data/countries_'.CMS_CURRENT_LANGUAGE.'.php');
			
			$landen=array_merge(array(''=>'Select your country'),$landen);
			$vars['country_select'] = form::selectList( 'country', $landen, $this->country);
			unset($landen);
			
			$vars['birthday']=inputDate('birthday',((empty($this->birthday) && !isset($_POST['birthday_month']))?315529200:mktime(0,0,0,$_POST['birthday_month'],$_POST['birthday_day'],$_POST['birthday_year'])));
			
			return cmstemplates::show( 'cmsusers_reg', $this->_tablename, $vars );
	}
	

	function checkRegistration($update=0)
	{
		
		if(!$update)$this->bind( $_POST );
		$this->check();
		
		$required=explode(',',CMS_FIELDS_REQUIRED);
		
		$error = array();
		$errors = array();
	
		if(!$update)
		{
		$this->confirmcode = rand( 10000, 99999 );
		$this->status = 'off';
		}
		if( !$this->givenname ) {
			$error[] = CMSUSERS_REG_ERROR_GIVENNAME;
			$errors['givenname']=1;
		}
		if( !$this->familyname ) {
			$error[] = CMSUSERS_REG_ERROR_FAMILYNAME;
			$errors['familyname']=1;
		}	
		if( !$this->email && !$update) {
			$error[] = CMSUSERS_REG_ERROR_EMAIL;
			$errors['email']=1;
		}
		elseif( !checkemail_format($this->email)  && !$update)
		{
			/* check emailadres */
			$error[] = CMSUSERS_REG_ERROR_EMAIL;
			$errors['email']=1;
		}	
		else if(!$update)
		{
			$rs = $this->_db->Execute( "SELECT id FROM ".$this->_tablename." WHERE email = '".$this->email."'" );

			if( $rs->RecordCount() ) {
				$error[] = CMSUSERS_REG_ERROR_DOUBLEE;
				$errors['email']=1;
		}
		}
		if($this->msn && !checkemail_format($this->msn))
		{
			$error[] = CMSUSERS_REG_ERROR_MSN;
			$errors['msn']=1;
		}
		
		/* required fields */
		foreach ($required as $item)
		{
			if(!$this->{$item})
			{
				$error[] = 'Empty or invalid value for <strong>'.$item.'</strong>';
				$errors[$item]=1;
			}	
		}	
		
			
		if(!$update && strlen( $this->username ) < 5 ) {
			$error[] = CMSUSERS_REG_ERROR_USERNAME;
			$errors['username']=1;
		} elseif(!$update) {
			$rs = $this->_db->Execute( "SELECT id FROM ".$this->_tablename." WHERE username = '".$this->username."'" );
			if( $rs->RecordCount() ) {
				$error[] = CMSUSERS_REG_ERROR_DOUBLEU;
				$errors['username']=1;
			}
		}
		if(!$update)
		{
		$pw1 = cleanPassword( $_POST['password1'] );	
		$pw2 = cleanPassword( $_POST['password2'] );	

		if(!$update &&  $pw1 == $pw2 ) {
			if( strlen( $pw1 ) > 4 ) {
				$this->password = md5( $pw1 );
			} else {
				$error[] = CMSUSERS_REG_ERROR_PASSWORD;
				$errors['password']=1;
			}
		} elseif(!$update) {
			$error[] = CMSUSERS_REG_ERROR_PWEQUAL;
			$errors['password']=1;
		}
		if(!$update &&  $this->username == $pw1 ) {
			$error[] = CMSUSERS_REG_ERROR_UPEQUAL;
			$errors['password']=1;
		}
		}
		return array($error,$errors);
	}

	function sendRegistrationMail()
	{
		$admin = CMS_ADMIN_NAME.' <'.CMS_ADMIN_EMAIL.'>';
		$newuser = $this->email;
		$subject = sprintf( CMSUSERS_REG_SUBJECT, CMS_DEFAULT_TITLE );
		$vars = get_object_vars( $this );
		if( $this->mailing == 'yes' ) {
			$vars['mailing'] = YES;
		} else {
			$vars['mailing'] = NO;
		}
		if( CMS_USERS_REGISTRATIONMETHOD == 'askadmin' ) {
			$vars['explain'] = CMSUSERS_REG_MAIL_ASKADMIN;
		} elseif( CMS_USERS_REGISTRATIONMETHOD == 'notifyadmin' ) {
			$vars['explain'] = CMSUSERS_REG_MAIL_NOTIFYADMIN;
			$notifymsg = cmstemplates::show( 'cmsusers_reg_notifyadmin.'.$this->language, $this->_tablename, $vars );
			sendEmail( $admin, '', '', $admin, $subject, $notifymsg, '' );
		} elseif( CMS_USERS_REGISTRATIONMETHOD == 'free' ) {
			$vars['explain'] = CMSUSERS_REG_MAIL_FREE;
		} else {
			//no registration allowed
			return FALSE;
		}
		$plaintext = cmstemplates::show( 'cmsusers_reg_mail_plain.'.$this->language, $this->_tablename, $vars );
		//$html = cmstemplates::show( 'cmsusers_reg_mail_html.'.$this->language, $this->_tablename, $vars );
		$html = '';
		return sendEmail( $newuser, '', '', $admin, $subject, $plaintext, $html);
	}

	function confirmRegistration()
	{
		$confirmcode = intval( substr( CMS_CURRENT_ID, 0, 5 ) );
		$id = intval( substr( CMS_CURRENT_ID, 5 ) );
		$msg = array();
		$sql = "SELECT id FROM ".$this->_tablename." WHERE id = '".$id."' AND confirmcode = '".$confirmcode."'";
		$rs = $this->_db->Execute( $sql );

		if( $rs->RecordCount() == 1 ) {
			$this->load( $id );
			$this->confirmcode = '';
			if( CMS_USERS_REGISTRATIONMETHOD == 'notifyadmin' || CMS_USERS_REGISTRATIONMETHOD == 'free' ) {
				$this->status = 'on';
			} else {
				$this->status = 'off';
				$vars = get_object_vars( $this );
				$subject = sprintf( CMSUSERS_REG_SUBJECT, CMS_DEFAULT_TITLE );
				$mail = cmstemplates::show( 'cmsusers_reg_askadmin.'.$this->language, $this->_tablename, $vars );
				sendEmail( CMS_ADMIN_EMAIL, '', '', CMS_ADMIN_EMAIL, $subject, $mail, '');
			}
			if( $this->save() ) {
				$msg['title'] = CMSUSERS_CONFIRMED;
				if( $this->status == 'on' ) {
					$msg['message'] = CMSUSERS_CONFIRMED_ON;
				} else {
					$msg['message'] = CMSUSERS_CONFIRMED_OFF;
				}
			} else {
				//saving failed? That should not have happened
				return FALSE;
			}
		} else {
			//confirmation failed, check if user exist-> you allready confirmed else ...
			$msg['title'] = CMSUSERS_CONFIRMED_FAIL;
			$msg['message'] = CMSUSERS_CONFIRMED_FAILEXPLAIN;
		}
		return cmstemplates::show( 'message', $this->_tablename, $msg );
	}
	
	function logout()
	{
		$this->unsetSession();
	}

	function setSession()
	{
		$_SESSION['username'] = $this->username;
		$_SESSION['time'] = time();
		$_SESSION['password'] = $this->password;
		define( 'CMS_CURRENT_USER_ID', $this->id );
		define( 'CMS_CURRENT_USER_NAME', $this->username );
		define( 'CMS_CURRENT_USER_TYPE', $this->type );
	}
	
	function unsetSession($constants=0)
	{
		if(!isset($_SESSION))session_start(); 
	    
		if(isset($_SESSION))
		{
		unset( $_SESSION['username'] );
		unset( $_SESSION['time'] );
		unset( $_SESSION['password'] );
		
		}
		if(!$constants && !defined( 'CMS_CURRENT_USER_TYPE' ) ) 
		{
			define( 'CMS_CURRENT_USER_ID', 0 );
			define( 'CMS_CURRENT_USER_NAME', '' );
			define( 'CMS_CURRENT_USER_TYPE', '' );
		}
	}
	
	function getStats()
	{
		if( $this->id ) {
			$rs = $this->_db->Execute( "SELECT * FROM ".$this->_tablename_stats." WHERE uid = '".$this->id."'" );
			if( $rs ) {
				$record = $rs->FetchRow();
				$i = $record['forumcount'];
				if( $i > 99 ) {
					$level = 6;
				} elseif( $i > 74 ) {
					$level = 5;
				} elseif( $i > 49 ) {
					$level = 4;
				} elseif( $i > 24 ) {
					$level = 3;
				} elseif( $i > 9 ) {
					$level = 2;
				} else {
					$level = 1;
				}
				$record['forumranking'] = $level;
				return $record;
			} else {
				return FALSE;
			}
		} else {
			return FALSE;
		}
	}

	function increaseForumCount( $id )
	{
		$id = intval( $id );
		if( $id ) {
			$rs = $this->_db->Execute( "UPDATE ".$this->_tablename_stats." SET forumcount = forumcount + 1 WHERE uid = '".$id."'" );
			if( $rs && $this->_db->affected_rows() == 1 ) {
				return TRUE;
			} elseif( $rs ) {
				return $this->_db->Execute( "INSERT INTO ".$this->_tablename_stats." ( uid, forumcount ) VALUES ( '".$id."', '1' )" );
			} else {
				return FALSE;
			}
		} else {
			return FALSE;
		}
	}

	function showLogin( $edit=1 ) 
	{
		
		/* uitloggen */
		if ( intval(CMS_CURRENT_USER_ID) && isset( $_POST['logout'] ) ) 
		{
			$this->load( CMS_CURRENT_USER_ID );
			$this->logout();
			if($edit)
			{
			$vars['title'] = CMSUSERS_LOGGEDOUT;
			$vars['message'] = CMSUSERS_LOGGEDOUT_MESSAGE;
			return cmstemplates::show( 'message', $this->_tablename, $vars );
			}
			else 
			{
				return cmstemplates::show( 'cmsusers_login', $this->_tablename, '' );
			}
		}
						
		elseif($edit && isset( $_POST['lostpassword'] ) ) 
		{
			return $this->sendNewPassword();
		} 
		elseif($edit && isset( $_GET['requestpassword'] ) ) 
		{
			return cmstemplates::show( 'cmsusers_lostpw', $this->_tablename, '' );
		} 
		
		elseif ( intval(CMS_CURRENT_USER_ID) ) 
		{
			$this->load( CMS_CURRENT_USER_ID );


			if($edit==1)
			{
				
				/* wijzigingsformlier tonen */
				$vars['edit'] = $this->editUser();
			
				if($this->hasRights('reviewer') ) 
				{
						$vars['admin'] = cmstemplates::show( 'cmsusers_toadmin', $this->_tablename, '' );
				}
						
			}
			if($edit==2)
			{
				
				return;
						
			}
			else
			{
			/*
			//logoutbutton
			$vars['logout'] = cmstemplates::show( 'cmsusers_logout', $this->_tablename, '' );			
			*/
			

				$vars['links']=$this->UserLinks();

				
			}
			
			return cmstemplates::show( 'cmsusers_loggedin', $this->_tablename, $vars );
		} 
		else 
		{
			/* toon het inlogformulier */
			return cmstemplates::show( 'cmsusers_login', $this->_tablename, '' );
		}
	}
	
	function UserLinks()
	{
		if ( !intval(CMS_CURRENT_USER_ID) ) return;
		$vars = array();
		$vars['logout'] = cmstemplates::show( 'cmsusers_logoutlink', $this->_tablename, '' );
		$vars['edit']=cmstemplates::show('cmsusers_editlink','cmsusers','');
		return cmstemplates::show('cmsusers_links','cmsusers',$vars);
	}	
	
	
	function sendNewPassword()
	{

		$email = cleanEmail( $_POST['email'] );
		$rs = $this->_db->Execute( "SELECT id FROM ".$this->_tablename." WHERE email='".$email."' AND status='on' AND NOT confirmcode" );
		if( $record = $rs->FetchRow() ) {
			$this->load( $record['id'] );
			$pw = generatePassword();
			$this->password = md5( $pw );
			$subject = sprintf( CMSUSERS_LOSTPASSWORD_SUBJECT, CMS_DEFAULT_TITLE );
			$vars = get_object_vars( $this );
			$vars['pw'] = $pw;
			$plaintext = cmstemplates::show( 'cmsusers_lostpw_plain.'.CMS_CURRENT_LANGUAGE, $this->_tablename, $vars );
			//$html = cmstemplates::show( 'cmsusers_lostpw_html.'.CMS_CURRENT_LANGUAGE, $this->_tablename, $vars );
			$html = '';
			if( sendEmail( $this->email, '', '', CMS_ADMIN_NAME.' <'.CMS_ADMIN_EMAIL.'>', $subject, $plaintext, $html ) ) {
				if( $this->save() ) {
					$msg['title'] = CMSUSERS_REQUEST_PASSWORD;
					$msg['message'] = CMSUSERS_LOSTPASSWORD_SEND;
	
				} else {
					//could not save, email send
					$msg['title'] = CMSUSERS_REQUEST_PASSWORD;
					$msg['message'] = CMSUSERS_LOSTPASSWORD_NOTSEND;
				}
			} else {
				//could not send e-mail
				$msg['title'] = CMSUSERS_REQUEST_PASSWORD;
				$msg['message'] = CMSUSERS_LOSTPASSWORD_NOTSEND;
			}
		} else {
			//failed, no such emailaddress
			$msg['title'] = CMSUSERS_REQUEST_PASSWORD;
			$msg['message'] = CMSUSERS_LOSTPASSWORD_NOTSEND;
	
		}
		return cmstemplates::show( 'message', $this->_tablename, $msg );
	}
	
	function verwijderprofiel($id)
	{
		$this->load($id);
		
		
		/* foto's verwijderen */
			
			if(!empty($this->photo))
			{
							@unlink(CMS_CLIENT_PATH.CMS_IMAGES_SCALED_DIR.$this->photo );
							@unlink(CMS_CLIENT_PATH.CMS_IMAGES_THUMBS_DIR.$this->photo );
							@unlink(CMS_CLIENT_PATH.CMS_IMAGES_ORIGINAL_DIR.$this->photo );
			}	
			
			/* stemmenlog verwijderen */
			
			if(file_exists(CMS_CLIENT_PATH.'stemmenlog/'.$this->username.'.txt'))
			{
				unlink(CMS_CLIENT_PATH.'stemmenlog/'.$this->username.'.txt');
			}	
			
			
			/* 
			
				berichtjes verwijderen 
			    alleen ontvangen berichtjes !!
			*/
			
			 $sql = 'DELETE FROM `cmsmessages` WHERE `receiver`='.$this->id;	
			
			 $this->_db->Execute( $sql );
			
			/* uit vriendenlijst verwijderen */
			
			 $sql = 'DELETE FROM `cmsfriends` WHERE `userid`='.$this->id.' OR `friendid`='.$this->id;	
			 $this->_db->Execute( $sql );
			
			 $this->delete();
			 return;
	}	

	function editUser()
	{
		/* vervangen door form class ?!! */		require_once CMS_LIB_PATH.'cmstemplates/cmstemplatesadmin.php';
		
		$vars = get_object_vars( $this );
		$message = '';
		
		if (isset($_POST['confirmeddelete']))
		{
			$this->verwijderprofiel(CMS_CURRENT_USER_ID);
			$this->logout();
			return cmstemplates::show('deleted','cmsusers',null); 
		}	
		
		if (isset($_POST['deleteprofile']))
		{
			return cmstemplates::show('confirmdelete','cmsusers',null); 
		}	
		
		if( isset( $_POST['users_edit'] ) ) 
		{
			$this->bind( $_POST );
			$this->id = CMS_CURRENT_USER_ID;
			
			/* controleren */
			
		list($errors,$errorclasses) = $this->checkRegistration(1);
		if( count($errors)>0 ) 
		{
				//errors did occur
				$templ = cmstemplates::loadfile( 'cmsusers_reg_error_item', $this->_tablename );
				$error_list = '';
				foreach( $errors as $error ) {
					$error_list .= cmstemplates::parse( $templ, array( 'error' => $error ) );
				}
				$vars['errors'] = cmstemplates::show( 'cmsusers_reg_errors', $this->_tablename, array( 'errors' => $error_list ) );
				
		}
		}
		if( isset( $_POST['change_password'] ) ) 
		{
		$errors = array();
		$errorclasses = array();	
		$pw1 = cleanPassword( $_POST['password1'] );	
		$pw2 = cleanPassword( $_POST['password2'] );	

		if( $pw1 == $pw2 ) {
			if( strlen( $pw1 ) > 4 ) {
				$this->password = md5( $pw1 );
			} else {
				$errors[] = CMSUSERS_REG_ERROR_PASSWORD;
				$errorclasses['password']=1;
			}
		} else {
			$errors[] = CMSUSERS_REG_ERROR_PWEQUAL;
			$errorclasses['password']=1;
		}
		if( $this->username == $pw1 ) {
			$errors[] = CMSUSERS_REG_ERROR_UPEQUAL;
			$errorclasses['password']=1;
		}
		$soort='pass';
		}	
			
			/*if( strlen( $_POST['password1'] ) > 4 && $_POST['password1'] == $_POST['password2'] ) {
				$this->password = md5( $_POST['password1']);
			} elseif( $_POST['password1'] ) {
				$message .= CMSUSERS_EDIT_PASSWORDSHORT;
			}*/
			
		if( !defined( 'CMS_IMAGES_SCALED_DIR' ) ) {
			define( 'CMS_IMAGES_SCALED_DIR', 'profielimg/' );
		}
		if( isset( $_POST['user_photo'] ) ) 
		{
		if( !defined( 'CMS_IMAGES_ORIGINAL_DIR' ) ) {
			define( 'CMS_IMAGES_ORIGINAL_DIR', 'profielimg/original/' );
		}
		if( !defined( 'CMS_IMAGES_THUMBS_DIR' ) ) {
			define( 'CMS_IMAGES_THUMBS_DIR', 'profielimg/thumbs/' );
		}
		if( !defined( 'CMS_IMAGES_SCALE_TYPE' ) ) {
			define( 'CMS_IMAGES_SCALE_TYPE', 'fit' );
		}
		if( !defined( 'CMS_IMAGES_SCALE_BLOWUP' ) ) {
			define( 'CMS_IMAGES_SCALE_BLOWUP', 'no' );
		}
		if( !defined( 'CMS_IMAGES_SCALED_SIZE' ) ) {
			define( 'CMS_IMAGES_SCALED_SIZE', '640x640' );
		}
		if( !defined( 'CMS_IMAGES_THUMBS_SIZE' ) ) {
			define( 'CMS_IMAGES_THUMBS_SIZE', '120x120' );
		}
		if( !defined( 'CMS_IMAGES_CATEGORY_TABLE' ) ) {
			//table size in [cols]x[rows]
			define( 'CMS_IMAGES_CATEGORY_TABLE', '7x3' );
		}
			
		$resize_type = CMS_IMAGES_SCALE_TYPE;
		if(exif_imagetype($_FILES['userfile']['tmp_name'])==1)$ext='gif';
		elseif(exif_imagetype($_FILES['userfile']['tmp_name'])==2)$ext='jpg';
		else $ext='pgn';
			
		$originalfilename = upload( $this->username.'.'.$ext, CMS_CLIENT_PATH.CMS_IMAGES_ORIGINAL_DIR,'yes');

		if( $originalfilename ) {
			$this->object->filename = basename( $originalfilename );
			$scaledfilename = CMS_CLIENT_PATH.CMS_IMAGES_SCALED_DIR.$this->object->filename;
			$thumbsfilename = CMS_CLIENT_PATH.CMS_IMAGES_THUMBS_DIR.$this->object->filename;
			if( filesize( $originalfilename ) < 52428800 ) {
				if( $size = getimagesize( $originalfilename ) ) {
					//it's an image
					$suc1 = resize( $originalfilename, $scaledfilename, CMS_IMAGES_SCALED_SIZE, $resize_type, CMS_IMAGES_SCALE_BLOWUP );
					$suc2 = resize( $originalfilename, $thumbsfilename, CMS_IMAGES_THUMBS_SIZE, $resize_type, CMS_IMAGES_SCALE_BLOWUP );
					if( $suc1 && $suc2 ) {
						
						if($this->photo!=$this->object->filename)
						{
							@unlink(CMS_CLIENT_PATH.CMS_IMAGES_SCALED_DIR.$this->photo );
							@unlink(CMS_CLIENT_PATH.CMS_IMAGES_THUMBS_DIR.$this->photo );
							@unlink(CMS_CLIENT_PATH.CMS_IMAGES_ORIGINAL_DIR.$this->photo );
						}	
						$this->photo=$this->object->filename;
						//return TRUE;
				 	} else {
						@unlink( $originalfilename );
						@unlink( $scaledfilename );
						@unlink( $thumbsfilename );
						//return FALSE;
					}
				} else {
					unlink( $originalfilename );
					//return FALSE;
				}
			} else {
				unlink( $originalfilename );
				//return FALSE;
			}
				
		} else {
			//return FALSE;
		}
		}
			
		if(isset($_POST))
		{	
			if(empty($errors))
			{
			$this->save();
			$vars = get_object_vars( $this );
			}
			/*else 
			{
				$templ = cmstemplates::loadfile( 'cmsusers_reg_error_item', $this->_tablename );
				$error_list = '';
				foreach( $errors as $error ) {
					$error_list .= cmstemplates::parse( $templ, array( 'error' => $error ) );
				}
				$vars['errors'.$soort] = '<div class="error">'.cmstemplates::show( 'cmsusers_reg_errors', $this->_tablename, array( 'errors' => $error_list ) ).'</div>';
				
			}	*/
		}

		$vars['gender_select'] = cmstemplatesadmin::selectList( 'gender', array( 'male' => CMSUSERS_MALE, 'female' => CMSUSERS_FEMALE ), $this->gender );
			include(CMS_LIB_PATH.'/data/countries_en.php');
			$landen=array_merge(array(''=>'Select your country'),$landen);
			$vars['country_select'] = form::selectList( 'country', $landen, $this->country);
			unset($landen);
			
			
		$langs = cmslanguages::getArray();
		if( count( $langs ) > 1 ) {
			$vars['language_select'] = cmstemplatesadmin::selectList( 'language', $langs, $this->language );
		} else {
			$vars['language_select'] = $langs[CMS_LANGUAGES_DEFAULT];
		}
		$vars['mailing_select'] = cmstemplatesadmin::selectList( 'mailing', array( 'no' => NO, 'yes' => YES ), $this->mailing );
		$vars['birthday']=inputDate('birthday',((!empty($this->birthday) && !isset($_POST['birthday_month']))?$this->birthday:(isset($_POST['birthday_month'])?mktime(0,0,0,$_POST['birthday_month'],$_POST['birthday_day'],$_POST['birthday_year']):'')));
		$vars['message'] = $message;
		
			if(isset($errorclasses) && is_array( $errorclasses))
			{
				foreach ($errorclasses as $k=>$v)
				{
					$vars[$k.'error']='error';
				}	
			}
		
		if(isset($_POST))$vars=array_merge($vars,$_POST);
		
		if(!empty($this->photo))
		{
			$vars['photo']=cmstemplatesadmin::show('img/img','cmstemplates',array('src'=>'/'.CMS_IMAGES_SCALED_DIR.$this->photo,'alt'=>'foto '.$this->username));
			
		}
		$vars['changepassword']='';
		if(CMS_CURRENT_USER_NAME!='demo')
		{
			$vars['changepassword']=cmstemplates::show( 'cmsusers_changepassword', $this->_tablename, $vars );
		}	
		$vars['deleteprofile'] = cmstemplates::show( 'deleteprofile', $this->_tablename, null );	
		return cmstemplates::show('cmsusers_edit', $this->_tablename, $vars );
		
		
	}
	
}
?>