<?php
ini_set('error_reporting', E_ALL);
ini_set('display_errors', true);
ini_set('memory_limit', '32M');
/*


*/  
function upload( $destname='', $destpath='./', $overwrite = 'no',$source='',$fieldname='userfile' )
{
	/*********************
	 * $destname = [filename of destination]
	 * $destpath = [path of destination]
	 * $overwrite = yes | no
	 *********************/

	if( !$destname ) {
		$destname =ereg_replace( "[^a-z0-9\.]", "", strtolower( $_FILES[$fieldname]['name'] ) );
		if(strlen($destname)>15)$destname = substr($destname,-15);
	}
	$filecounter = 0;

	while( $overwrite <> 'yes' && file_exists( $destpath.$destname ) ) {
		$filecounter++;
		$destname = 'osc'.sprintf("%05u", $filecounter).substr( $destname, -6, 6);
	}

	if( isset($_FILES[$fieldname]['tmp_name']) && move_uploaded_file( $_FILES[$fieldname]['tmp_name'], $destpath.$destname ) ) 
	{
		chmod( $destpath.$destname, 0666 );
		return $destpath.$destname;
	}
	

	elseif(!empty($source) )  {
		/* 
		maybe not the safest way 
		add for cmsmegadownloads
		*/
		rename($source, $destpath.$destname);
		return $destpath.$destname;
	}
	else {
		return FALSE;
	}
}

function resize( $filename, $destname='', $resize='50x50', $resizetype='fit', $blowup='yes' )
{
	/*********************** 
	 * Uses GD to resize an image
	 * $filename = [source filename]
	 * $destname = [destination filename] (default = $filename)
	 * $resize = [x-value]x[y-value]
	 * $resizetype = fit | fullfit | crop | fullcrop
	 * $blowup = yes | no (yes = blowup smaller images, no=do not scale smaller images)
	 ***********************/

	if( !$destname ) {
		$destname = $filename;
	}
	if( $resize && $resize<>'0x0' ) {
		$maxsize = explode( 'x', $resize );
		$size = getimagesize( $filename );
		switch( $size[2] ) {
			default:
				return FALSE;
			break;
			case IMAGETYPE_GIF:
				$source = imagecreatefromgif( $filename );
			break;
			case IMAGETYPE_JPEG:
				$source = imagecreatefromjpeg( $filename );
			break;
			case IMAGETYPE_PNG:
				$source = imagecreatefrompng( $filename );
			break;
			case IMAGETYPE_WBMP:
				$source = imagecreatefromwbmp( $filename );
			break;
			case IMAGETYPE_XPM:
				$source = imagecreatefromxpm( $filename );
			break;
			case IMAGETYPE_XBM:
				$source = imagecreatefromxbm( $filename );
			break;
		}
		if( $blowup == 'no' && $size[0] < $maxsize[0] && $size[1] < $maxsize[1] ) {
			$dest = imagecreatetruecolor( $size[0], $size[1] );
			$scale_success = imagecopy( $dest, $source, 0, 0, 0, 0, $size[0], $size[1] );
			$cut_success = TRUE;				
			imagedestroy( $source );	
		} elseif( $resizetype == 'crop' ) {
			if( $size[0] > $maxsize[0] ) {
				$newwidth	= $maxsize[0];
				$x		= round( ( $maxsize[0] - $size[0] ) / 2, 0 );
			} else {
				$newwidth	= $size[0];
				$x		= 0;
			}
			if( $size[1] > $maxsize[1] ) {
				$newheight	= $maxsize[1];
				$y		= round( ( $maxsize[1] - $size[1] ) / 2, 0 );
			} else {
				$newheight	= $size[1];
				$y		= 0;
			}
			$dest = imagecreatetruecolor( $newwidth, $newheight );
			
			/* make transparant */
			imagesavealpha($dest, true);
    		$trans_colour = imagecolorallocatealpha($dest, 0, 0, 0, 127);
    		imagefill($dest, 0, 0, $trans_colour);
			
			
			$cut_success = imagecopy( $dest, $source, $x, $y, 0, 0, $size[0], $size[1] );
			$scale_success = TRUE;
			imagedestroy( $source );
		} elseif( $resizetype == 'fullcrop' ) {
			if( ( $maxsize[0] / $size[0] ) < ( $maxsize[1] / $size[1] ) ) {
				$tmpwidth 	= round( $maxsize[1] * ( $size[0] / $size[1] ), 0 );
				$newwidth 	= $maxsize[0];
				$newheight 	= $tmpheight = $maxsize[1];
				$x		= round( ( $newwidth - $tmpwidth ) / 2, 0 );
				$y		= 0;
			} else {
				$newwidth 	= $tmpwidth = $maxsize[0];
				$tmpheight 	= round( $maxsize[0] * ( $size[1] / $size[0] ), 0 );
				$newheight 	= $maxsize[0];
				$x		= 0;
				$y		= round( ( $newheight - $tmpheight ) / 2, 0 );
			}
			$temp = imagecreatetruecolor( $tmpwidth, $tmpheight );
			$scale_success = imagecopyresampled( $temp, $source, 0, 0, 0, 0, $tmpwidth, $tmpheight, $size[0], $size[1] );
			imagedestroy( $source );
			$dest = imagecreatetruecolor( $newwidth, $newheight );
			$cut_success = imagecopy( $dest, $temp, $x, $y, 0, 0, $tmpwidth, $tmpheight );
			imagedestroy( $temp );
		} elseif( $resizetype == "fit" ) {
			if( ( $maxsize[0] / $size[0] ) < ( $maxsize[1] / $size[1] ) ) {
				$newwidth =	$maxsize[0];
				$newheight =	round( $maxsize[0] * ( $size[1] / $size[0] ), 0 );
			} else {
				$newwidth =	round( $maxsize[1] * ( $size[0] / $size[1] ), 0 );
				$newheight =	$maxsize[1];
			}
			$dest = imagecreatetruecolor( $newwidth, $newheight );
			
			/* make transparant */
			imagesavealpha($dest, true);
    		$trans_colour = imagecolorallocatealpha($dest, 0, 0, 0, 127);
    		imagefill($dest, 0, 0, $trans_colour);
			
			
			$scale_success = imagecopyresampled( $dest, $source, 0, 0, 0, 0, $newwidth, $newheight, $size[0], $size[1] );
			$cut_success = TRUE;
			imagedestroy( $source );
		} elseif( $resizetype == 'fullfit' ) {
			$newwidth	= $maxsize[0];
			$newheight	= $maxsize[1];
			$dest = imagecreatetruecolor( $newwidth, $newheight );
			$scale_success = imagecopyresampled( $dest, $source, 0, 0, 0, 0, $newwidth, $newheight, $size[0], $size[1] );
			$cut_success = TRUE;
			imagedestroy( $source );
		} else {
			return FALSE;
		}
		if( $scale_success && $cut_success ) {
			switch( $size[2] ) {
				default:
					$save_success = imagepng( $dest, $destname );
				break;
				case IMAGETYPE_JPEG:
					$save_success = imagejpeg( $dest, $destname );
				break;
			}
			if( $save_success ) {
				chmod( $destname, 0644 );
				return imagedestroy( $dest );
			} else {
				return FALSE;
			}
		} else {
			return FALSE;
		}
	} else {
		return TRUE; //No resizing needed
	}
}

function convert( $source, $dest='', $size='72dpi' )
{
	/*****************************
	 * Uses ImageMagick to convert a file into a PNG image (ie. for thumbnails)
	 * $source = [full path & name of source file]
	 * $dest = [full path & name of destination file (default = $source'.png')
	 * $size = [x-value]x[y-value] or [int]dpi
	 *****************************/

	if( !$dest ) {
		$dest = $source.'.png';
	}
	if( file_exists( $source ) ) {
		//some strange files ( ie. example.h ) are not identified by ImageMagick but will result in strange PNG's
		//I tried to overcome this by using the three lines below, but it didn'y work either...
		//exec( 'identify -format "%m" '.$source, $idoutput, $idresult );
		//$format = trim( strtoupper( $idoutput[0] ) );
		//if( strlen( $format ) < 2 || strlen( $format ) > 5 ) return FALSE;

		if( ereg( "[0-9]+x[0-9]+", $size ) ) {	
			exec( 'convert -size '.$size.' '.$source.'[0] -resize '.$size.' '.$dest, $alloutput, $result );
		} elseif( ereg( "[0-9]+dpi", $size ) ) {
			exec( 'convert -density '.intval($size).'x'.intval($size).' '.$source.'[0] '.$dest, $alloutput, $result );
		} else {
			return FALSE;
		}
		if( $result ) {
			@unlink( $dest );
			return FALSE;
		} else {
			return TRUE;
		}
	}
	return FALSE;
}

function identify( $file )
{
	/*****************************
	 * Uses ImageMagick to identify a file and get some details
	 * $file = [full path & name of file]
	 * It returns an array with all kind of details or false if it can't identify the file
	 *****************************/

	if( file_exists( $file ) ) {
		$output1 = exec( 'identify -format "|%b|%w|%h|%x|%y|%m|%q|%c|" '.$file.'[0]', $alloutput1, $result1 );
		$output2 = exec( 'identify -format "%n" '.$file, $alloutput2, $result2 );
		if( $result1 || $result2 ) {
			return FALSE;
		} else {
			$d = explode( '|',$alloutput1[0] );
			$details['filesize']	= ereg_replace( "[^a-zA-Z0-9\.,]", "", $d[1] );
			$details['pxwidth']	= intval( $d[2] );
			$details['pxheight']	= intval( $d[3] );
			$details['xres']	= intval( $d[4] );
			if( !$details['xres'] ) $details['xres'] = 72;
			$details['yres']	= intval( $d[5] );
			if( !$details['yres'] ) $details['yres'] = 72;
			$details['type']	= ereg_replace( "[^A-Z]", "", strtoupper( $d[6] ) );
			$details['colordepth']	= intval( $d[7] );
			$details['comment']	= trim( $d[8] );
			$details['mmwidth']	= round( $details['pxwidth'] * 2.54 / $details['xres'], 0 );
			$details['mmheight']	= round( $details['pxheight'] * 2.54 / $details['yres'], 0 );
			$details['pages'] 	= intval( $alloutput2[0] );
			if( !$details['pages'] ) $details['pages'] = 1;
			return $details;
		}
	} else {
		return FALSE;
	}
}

function type2icon( $type ) {
	/*****************************
	 * Converts the ImageMagick image type to a filename for mimetype icons
	 * $type should be a type like ImageMagick would return with "identify"
	 * It's aimed at usage with the slick iconset
	 *****************************/

	$type = strtoupper( $type );
	$convert = array(
		//postscript
		'PDF'	=> 'pdf',
		'PS'	=> 'postscript',
		'EPS'	=> 'postscript',

		//packages and archives
		'ZIP'	=> 'archive',
		'ARJ' 	=> 'archive',
		'RAR'	=> 'archive',
		'LHA'	=> 'archive',
		'SIT'	=> 'archive',
		'CAT'	=> 'archive',
		'BZ'	=> 'archive',
		'GZ'	=> 'archive',
		'BZ2'	=> 'archive',
		'TBZ'	=> 'tgz',
		'TGZ'	=> 'tgz',
		'TAR'	=> 'tar',
		'DEB'	=> 'deb',
		'RPM'	=> 'rpm',

		//images
		'TIFF'	=> 'image',
		'BMP'	=> 'image',
		'PICT'	=> 'image',
		'PBM'	=> 'image',
		'PNM'	=> 'image',
		'PGM'	=> 'image',
		'XPM'	=> 'image',
		'XCF'	=> 'xcf',
		'GIF'	=> 'image',
		'PNG'	=> 'image',
		'JPG'	=> 'image',
		'JPEG'	=> 'image',
		'JPE'	=> 'image',
		'PCX'	=> 'image',

		//programming
		'PY'	=> 'source_py',
		'PL'	=> 'source_pl',
		'SH'	=> 'shellscript',
		'C'	=> 'source_c',
		'CPP'	=> 'source_cpp',
		'F'	=> 'source_f',
		'H'	=> 'source_h',
		'JAVA'	=> 'source_java',
		'JAR'	=> 'jar',
		'L'	=> 'source_l',
		'O'	=> 'source_o',
		'P'	=> 'source_p',
		'MOC'	=> 'source_moc',
		'S'	=> 'source_s',
		'Y'	=> 'source_y',
		'RUBY'	=> 'ruby',
		'PHP'	=> 'source',
		'PHTML'	=> 'source',
		'HTML'	=> 'html',
		'HTM'	=> 'html',
		'XHTML'	=> 'html',
		'CSS'	=> 'html',
		'XML'	=> 'html',
		'HTML'	=> 'html',
		'ASP'	=> 'html',
		'CGI'	=> 'html',
		'JSP'	=> 'html',
		'JS'	=> 'html',

		//tex
		'TEX'	=> 'tex',
		'LATEX'	=> 'latex',
		'DVI'	=> 'dvi',

		//wordprocessing
		'SXW'	=> 'wordprocessing',
		'SDW'	=> 'wordprocessing',
		'WPD'	=> 'wordprocessing',
		'SAM'	=> 'wordprocessing',
		'RTF'	=> 'wordprocessing',
		'KWD'	=> 'wordprocessing',
		'DOC'	=> 'ms_word',
		'DOT'	=> 'ms_word',

		//spreadsheet
		'SXC'	=> 'spreadsheet',
		'SDC'	=> 'spreadsheet',
		'DIF'	=> 'spreadsheet',
		'CSV'	=> 'spreadsheet',
		'KSP'	=> 'spreadsheet',
		'XLS'	=> 'ms_excel',
		'XLT'	=> 'ms_excel',

		//presentation
		'SXI'	=> 'document',
		'SDD'	=> 'document',
		'KPR'	=> 'document',
		'PPS'	=> 'ms_powerpoint',
		'PPT'	=> 'ms_powerpoint',

		//database
		'DBF'	=> 'document',
		'MDB'	=> 'ms_access',

		//sound & music
		'MP3'	=> 'mp3',
		'OGG'	=> 'sound',
		'WAV'	=> 'sound',
		'WMA'	=> 'sound',
		'FLAC'	=> 'sound',
		'MID'	=> 'midi',
		'MIDI'	=> 'midi',
		'AU'	=> 'sound',
		'SND'	=> 'sound',
		'RA'	=> 'real_doc',
		'RAM'	=> 'real_doc',
		'SND'	=> 'sound',

		//vector gfx
		'SWF'	=> 'vectorgfx',
		'SVG'	=> 'vectorgfx',
		'AI'	=> 'vectorgfx',
		'SXD'	=> 'vectorgfx',
		'SDA'	=> 'vectorgfx',
		'WMF'	=> 'vectorgfx',
		'EMF'	=> 'vectorgfx',
		'DIA'	=> 'vectorgfx',
		'CHRT'	=> 'vectorgfx',
		'FLW'	=> 'vectorgfx',

		//CAD CAM
		'DWG'	=> 'vectorgfx',
		'DXF'	=> 'vectorgfx',
		
		//messages
		'MSG'	=> 'message',
		'MBOX'	=> 'message',

		//dtp
		'KUT'	=> 'gettext',
		'SLA'	=> 'gettext',
		'QXD'	=> 'gettext',
		'IND'	=> 'gettext',
		'INDD'	=> 'gettext',
		'SCD'	=> 'gettext',

		//project & planning
		'MPP'	=> 'document',
		'MPX'	=> 'document',

		//binary
		'BIN'	=> 'binary',
		'EXE'	=> 'binary',
		'LIB'	=> 'binary',
		'DLL'	=> 'binary',

		//mpeg
		'MPG'	=> 'video',
		'MPEG'	=> 'video',
		'VOB'	=> 'video',
		'AVI'	=> 'video',
		'MOV'	=> 'video',
		'QT'	=> 'video',
		'MPE'	=> 'video',
		'MOVIE'	=> 'video',
		'VDO'	=> 'video',
		'VN'	=> 'video',
		'VIVO'	=> 'video',

		//address & calendars
		'ICAL'	=> 'document',
		'VCAL'	=> 'document',
		'LDIF'	=> 'person',
		'VCF'	=> 'vcard',

		//fonts
		'TTF'	=> 'font_truetype',
		'OTF'	=> 'font_truetype',
		'PFB'	=> 'font_type1',
		'PFA'	=> 'font_type1',
		'AFM'	=> 'font_type1',
		'PFM'	=> 'font_type1',
		'GSF'	=> 'font_type1',
			
		//div
		'ASCII'	=> 'ascii',
		'ISO'	=> 'cdimage',
		'TXT'	=> 'txt',
		'SGML'	=> 'wordprocessing'
	);

	if( isset( $convert[$type] ) ) {
		$result = $convert[$type];
	} else {
		$result = 'mime_empty';
	}
	return $result;
}

function mmfilesize($filepath,$new=1)
{
	/*
	uitleg te vinden op http://nl.wikipedia.org/wiki/Kilobyte
	*/
	$filesize = filesize($filepath );
	if( $filesize > 1073741824 ) {
			$filesize = round($filesize / 1073741824, 1).($new?'GiB':'GB');
	} elseif( $filesize > 1048576 ) {
			$filesize = round($filesize / 1048576, 1).($new?'MiB':'MB');
	} elseif( $filesize > 1024 ) {
			$filesize = round($filesize / 1024, 1).($new?'KiB':'kB');
	}
	return $filesize;
	
}	

function mmfiletype($filename)
{
	$type = strtoupper( substr( $filename, (strrpos( $filename, '.' )+1) ) );
	if($type=='DOC')$type='Word';
	return $type;
}	

?>
